function [A,Q]=QRSCHRITT(A,lambda,k,l,Q)
% [A,Q]=QRSCHRITT(A,lambda,k,l,Q)
% A=QRSCHRITT(A,lambda,k,l)
%
% Impliziter QR-Einzelshift fuer symmetrische, tridiagonale Matrizen A
%
%                     / A(1:k,1:k)       0              0        \
% A hat die Form  A = |     0      A(k+1:l,k+1:l)       0        |
%                     \     0            0        A(l+1:n,l+1:n) /
%
% Dabei ist A(l+1:n,l+1:n) diagonal, A(k+1:l,k+1:l) nichtzerfallende
% symmetrische tridiagonale Matrix mit l-k>=2
%
% Fuer A(k+1:l,k+1:l) wird ein impliziter QR-Einzelshift durchgefuehrt.
%
% -----------------------------------------------------------------------------------------------
% Input
% -----
% A         reelle symmetrische tridiagonale Matrix
% lambda    gegebener Einzelshift
% Q         OPTIONAL, akkumulierte Eigenvektormatrix
%
% -----------------------------------------------------------------------------------------------
% Output
% ------
% A         reelle symmetrische tridiagonale Matrix, nach dem QR-Schritt
% Q         OPTIONAL, akkumulierte Eigenvektormatrix. D.h. zerlegt man IMPLIZIT
%                     (nicht explizit!) A-lambda*I = Q1*R1, so ist Q durch Q*Q1
%                     zu ersetzen


% Ob Q als Inputparameter vorhanden ist, erfaehrt man dadurch ob die
% Systemvariable 'nargin' (Anzahl Inputargumente) den Wert 5 hat oder nicht


