function [A,nqr,Q]=SYMQRALG(A)
% [A,nqr,Q]=SYMQRALG(A)
%
% QR Algorithmus fr symmetrische Matrizen mit QR-Schritt aus der
% Funktion QRSCHRITT 
%
% -----------------------------------------------------------------------------
%
% Input/Output
% ------------
% A      nxn reelle symmetrische Matrix
% 
% -----------------------------------------------------------------------------
%
% Output
% ------
% nqr    Anzahl QR-Schritte
% Q      OPTIONAL, Eigenvektor-Matrix


n=size(A,1);
if nargout==3
   Q=eye(n);
end

k=0;
l=n;
flag=-1;
nqr=0;
while flag
   % Deflation
   m=0;
   for i=l-1:-1:k+1
       if abs(A(i+1,i))<=eps*(abs(A(i,i))+abs(A(i+1,i+1)))
	  A(i+1,i)=0;
	  A(i,i+1)=0;
	  if m==0
	     l=i;
	  else % m>1
	     k=i;
	  end
       else
	  m=m+1;
       end
   end
   if m<=1 
      m=0;
      for i=k:-1:1
	  if A(i+1,i)==0 
	     if m==0
		l=i;
	     else % m>1
		k=i;
	     end
	  else
	     m=m+1;
	  end
      end
   end
   if m==0
      flag=0;
   end

  
   
   if flag
      % Bestimme Eigenwert des unteren 2x2-Blocks
      ll=eig((A(l-1:l,l-1:l)+A(l-1:l,l-1:l)')*(1/2));
      if abs(ll(1)-A(l,l))<abs(ll(2)-A(l,l))
	 lambda=ll(1);
      else
	 lambda=ll(2);
      end
      if nargout==3
	 [A,Q]=QRSCHRITT(A,lambda,k,l,Q);
      else
	 A=QRSCHRITT(A,lambda,k,l);
      end

      nqr=nqr+1;
   end
end



