addpath('../routines/');
addpath('../examples/');

strgmat{1}='tridiag[-1 2 -1]';
strgmat{2}='Zufaellig erzeugte symmetrische Matrix';
strgmat{3}='ENDE';

strgalg{1}='eigener Algorithmus ohne Eigenvektoren';
strgalg{2}='Funktion `eig` aus MATLAB ohne Eigenvektoren';
strgalg{3}='eigener Algorithmus mit Eigenvektoren';
strgalg{4}='Funktion `eig` aus MATLAB mit Eigenvektoren';
strgalg{5}='Vergleich aller';
strgalg{6}='ENDE';



% Anzahl Testmatrizen pro Dimension
anz=5;
v=10:10:100;

method=0;
method=menu('Welches Verfahren?',strgalg);
if method==6
   return
end
fprintf('%s\n',strgalg{method})
while method<6

      mat=0;
      mat=menu('Welche Matrix?',strgmat);
      if mat==3
	 return
      end
      if mat==1
	 anz=1;
      else
	 anz=5;
      end
      fprintf('%s\n',strgmat{mat})

      clear legendtxt1  legendtxt2
      i=1;
      if method==1 | method==5
	 legendtxt1{i}='`SYMQRALG` o. Eigenv.';
	 i=i+1;
      end 
      if method==2 | method==5
	 legendtxt1{i}='`eig` o. Eigenv.';
      end 
      i=1;
      if method==3 | method==5
	 legendtxt2{i}='`SYMQRALG` m. Eigenv.';
	 i=i+1;
      end 
      if method==4 | method==5
	 legendtxt2{i}='`eig` m. Eigenv.';
      end 
      fl=zeros(4,length(v));
      fehler=zeros(2,length(v));
      nqr=zeros(2,length(v));
      j=1;
      fprintf(' n | Iter. |   Zeit ohne V   |   Zeit mit V    |Fehler der Zerlegung\n');
      fprintf('   |pro Ew.|SYMQRALG|  eig   |SYMQRALG|  eig   |SYMQRALG|  eig   \n');
      fprintf('-----------------------------------------------------------------\n');
      
      for n=v
	 for i=1:anz
	    if mat==1
	       A=full(spdiags(ones(n,1)*[-1 2 -1],-1:1,n,n));
	    else
	       A=randn(n)-.5;
	       A=triu(tril(A,1),-1);
	       A=A+A';
	    end
	    
	    if method==1 | method==5
	       % Hessenbergreduktion, ohne V
	       t0 = clock;
	       [Lambda1,m]=SYMQRALG(A);
	       fl(1,j)=fl(1,j)+etime(clock,t0); 
	       nqr(1,j)=nqr(1,j)+m; 
	    end
	    
	    if method==2 | method==5
	       t0 = clock;
	       Lambda2=eig(A);
	       fl(2,j)=fl(2,j)+etime(clock,t0); 
	    end
	
	    if method==3 | method==5
	       % Hessenbergreduktion, mit V
	       t0 = clock;
	       [Lambda3,m,Q3]=SYMQRALG(A);
	       fl(3,j)=fl(3,j)+etime(clock,t0); 
	       fehler(1,j)=fehler(1,j)+norm(Q3*Lambda3*Q3'-A,1);
	       nqr(2,j)=nqr(2,j)+m; 
	    end
	    
	    if method==4 | method==5
	       t0 = clock;
	       [Q4,Lambda4]=eig(A);
	       fl(4,j)=fl(4,j)+etime(clock,t0); 
	       fehler(2,j)=fehler(2,j)+norm(Q4*Lambda4*Q4'-A,1);
	    end
	    
	 end % for i

	 fl(:,j)=fl(:,j)/anz;
	 fehler(:,j)=fehler(:,j)/anz;
	 nqr(:,j)=nqr(:,j)/(n*anz);
	 fprintf('%3d|%6.2f |%8.1e|%8.1e|%8.1e|%8.1e|%8.1e|%8.1e\n',n,...
	     nqr(1,j),fl(1,j),fl(2,j),fl(3,j),fl(4,j),fehler(1,j),fehler(2,j));
	 j=j+1;
      end % for n

      figure(1);
      clf
      if method<=2 | method==5
	 if method==1 | method==5
	    loglog(v, fl(1,:), '+r');
	    hold on
	 end
	 if method==2 | method==5
	    loglog(v, fl(2,:),'og');
	 end
	 hold off
	 title('Rechenzeit QR-Iteration OHNE Eigenvektoren');
	 xlabel('n');
	 ylabel('Zeit [sec]');
	 legend(legendtxt1)
      end
      
      figure(3);
      clf
      figure(2);
      clf
      if method>=3
	 if method==3 | method==5
	    loglog(v, fl(3,:), '+r');
	    hold on
	 end
	 if method==4 | method==5
	    loglog(v, fl(4,:),'og');
	 end
	 hold off
	 title('Rechenzeit QR-Iteration MIT Transf.');
	 xlabel('n');
	 ylabel('Zeit [sec]');
	 legend(legendtxt2)
	 figure(3);
	 clf
	 if method==3 | method==5
	    semilogx(v, fehler(1,:),'+r');
	    hold on
	 end
	 if method==4 | method==5
	    semilogx(v, fehler(2,:),'og');
	 end
	 hold off
	 title('Genauigkeit QR-Iteration');
	 xlabel('n');
	 ylabel('gemittelter Fehler');
	 legend(legendtxt2)
      end
      
      method=menu('Welches Verfahren?',strgalg);
      if method==6
	 return
      end
      fprintf('%s\n',strgalg{method})

end % while

